;
.include "Header.inc"       ;Label und Werte Zuweisungen
.include "Hardware.inc"     ;Hardware Label  Zuweisungen
;
;Programmstart nach RESET  ( Interrupt Vektoren Tabelle )
;
.CSEG                       ;Was ab hier folgt kommt in den FLASH-Speicher
.ORG $0000                  ;Programm beginnt an der FLASH-Adresse 0x0000..
 rjmp  _reset               ;..mit der RESET-Vectortabelle

.include "IRQm88PA.inc"     ;Restliche Interrupt Vektortabelle

.ORG INT_VECTORS_SIZE       ;Programmadresse nach den ganzen IRQ-Vektoren
;
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;I Erstinitialisierungen
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;
;Stapelzeiger initialisieren (fuer Unterprogramme und / oder Interrupts)
;
_reset:
 ldi  a,High(RAMEND)        ;RAMEND, also das Ende vom SRAM, ist in der.. 
 out  SPH,a                 ;..Definitions-datei festgelegt  
 ldi  a,Low (RAMEND)
 out  SPL,a
;
;Timer/Counter2: Phase Correct PWM-Mode ( 5 ) initialisieren, NON-INVERT, 
;ohne Vorteiler. Clear OC2B on Compare Match upcounting, set OC2B on Compare 
;Match downcounting. OC2B ist der PWM-Pin, da OCR2A ja den TOP-Wert enthlt
;Pin17/PB3 ( OC2A ) ist als normaler I/O-Pin konfiguriert. TOV2-Flag bei BOTTOM.
;
 ldi  a,#pcpwm_freq         ;5,5kHz an OC2B einstellen,..
 sts  OCR2A,a	            ;..
 sts  OCR2B,null			;Erstmal keine PWM sondern Low-Pegel

ldi  a,3					;-------------------------------------------------------------
sts  OCR2B,a				;--------------------------------------------------------------

 ldi  a,NINV2B				;Phase Correct PWM-Mode 5, Non Inverting..
 sts  TCCR2A,a              ;..Upcouting clear OC0B on Compare Match, Down-..
 ldi  a,1<<CS20|1<<WGM22    ;...counting set OC0B on Compare Match, ohne Vor-..
 sts  TCCR2B,a              ;..teiler, Timer/Counter0 starten und..
 sbi  PWM2B_DDR,pwm2b.oc2b  ;..PWM-Portpin5/PD3 ( OC2B ) freigeben
 
 rjmp PC					;Endlosschleife ( PC = Program Counter )