; 
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;U Beginn der verwendeten Unterprogramme
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Motor stillsetzen
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
_encoder_taster:
 ldi  a,#pcpwm_freq			;Pulsdauer auf Maximum setzen (Out=High) und somit..
 sts  PULS,a	            ;..( Enable ) an dass SFR-Register OCR2B uebergeben.
 cbi  LED_PORT,led.in_1		;Maske f. Motorbremsung ( IN_1 = IN_2 )..
 cbi  LED_PORT,led.in_2		;..in Verbindung mit EN = High
 
 in   a,LED_PORT			;Port f. L298N Richtungssteuerung
 ldi  b,1<<led.in_1|1<<led.in_2 ;Maske f. Gegenrichtung..
 eor  a,b					;..Motor in Gegenrichtung steuern und..
 out  LED_PORT,a			;..Gegenrichtung aktivieren
 ldi  a,#gegenrichtung		;Zeitwert f. Gegengrichtung laden..
_gegenrichtung: 
 dec  a						;..eine Zeiteinheit abziehen bis Null..
 brne _gegenrichtung		;..Zeiteinheit Null? NEIN -> Weiter dekrementieren
 
 ;ldi  a,pcpwm_freq			;Maximale Pulsweite f. BTS7960 ( Out=High ) 
 ;sts  PULS,r_puls          ;..an das SFR-Register OCR2B uebergeben.
 
 ;sbrc key_reg,key.actuated  ;Wurde der Drehgebertaster betaetigt?
 clr   flanken_zlr		    ;JA -> Motorimpulszaehler ruecksetzen

 cbr  key_reg,1<<key.actuated;Tastererkennung wieder freigeben
 cbr  flag_reg,1<<mot.rechts;Flag-Motordrehrichtung Rechts loeschen
 cbr  flag_reg,1<<mot.links ;Flag-Motordrehrichtung Links  loeschen
 
 ret						;Ruecksprung aus _encoder_taster
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;PID-Regler
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Regeldiffernz (Error) zwischen dem Sollwert ( Fuehrungsgroesse w ) 
;und dem Istwert ( Regelgroesse x ) bilden.
;RegDiff_H:RegDiff_L = Sollwert - Istwert
;Input  Variable = #sollwert   ( Impulsflanken-Sollwert )
;Output Variable = RegDiff_H:RegDiff_L   Vorzeichenbehafteter Fehler ( Error ).
;
_pid_regler:
 ldi  b,#flanken_soll		;Impulsflanken-Sollwert laden
 clr  RegDiff_H				;Highbyte der Regeldiffernz loeschen
 sub  b,flanken_zlr			;Regeldiffernz bilden (Soll - Ist)
 brcc pc+2					;Was there a Borrow?	
 dec  RegDiff_H				;If Yes then PrerrH = $ff; Else EOH = $00
 mov  RegDiff_L,b			;store in current Error
;
;Proportionalanteil
;
;AccumH:AccumL = RegDiff_H:RegDiff_L * Kp
;Kp = 8   durch drei mal links schieben
;Input  Variable = RegDiff_H:RegDiff_L = Error und Kp ist Proportionalfaktor
;Output Variable = AccumH:AccumL =  Proportional Component.
;
_Proporotional:
 movw AccumH:AccumL,RegDiff_H:RegDiff_L	;Mov Error into Sum
 
 ;lsl  AccumL				;Multiply Sum by 8
 ;rol  AccumH
 ;lsl  AccumL				
 ;rol  AccumH
 ;lsl  AccumL				;Proportional result in Sum 
 ;rol  AccumH
 
 mov  r_puls,AccumL			;Update PWM Duty Cycle
;
;Intergralanteil
;
;Multiplies Present Error by Ki and adds result to IntegH:IntegL
;IntegH:IntegL =IntegH:IntegL + PrerrH:PrerrL * Ki: Ki = 8
;Input Variablen:	
;RegDiff_H:RegDiff_L	: Regeldiffernz ( Error )
;Integr_H:Integr_L		: Running Error Total
;Ki						: Integral Gain factor
;Output Variable:		
;Integr_H:Integr_L		: Integral Component.
;
_Integral:
; movw PaerrH:PaerrL,PrerrH:PrerrL	;Update Previous Error ;Wenn Diffenentialanteil auch noch gebraucht wirde

; lsl  RegDiff_L				;Multiply Error by 8
 ;rol  RegDiff_H
 ;lsl  PrerrL				
 ;rol  PrerrH
 ;lsl  PrerrL				
 ;rol  PrerrH

 add Integr_L,RegDiff_L			;Add Result to Integral
 adc Integr_H,RegDiff_H
;	
;Stellgroesse ( Y )
;
;Additon vom Proportional,- Interral,- und Diffenzialanteilen
;Stell_H:Stell_L =	Integr_H:Integr_L + Delta_H:Delta_L + ProH:ProL * Kd
;Input Variablen:	Integr_H:Integ_L, Pwm_H:Pwm_L, Delta_H:Delta_L 
;Output Variable:	Stell_H:Stell_L		;Summe der Einzelanteile  
;
_stellgroesse:
 add  Stell_L,Integr_L		;Addieren des..
 add  Stell_H,Integr_H		;..Integralanteils

 ;add  Stell_L,Delta_L		;Addieren des..
 ;add  Stell_H,Delta_H		;..Diffenzialanteils

 brpl pc+4					;Stellgroessensummer negativ?
 clr  Stell_H				;JA -> Stellgroesse.. 
 clr  Stell_L				;..gleich Null setzen
 rjmp _stell_null			;Pulsweite aktualisieren
 	
 lsr  Stell_H				
 ror  Stell_L
 ;lsr  AccumH				;Divide Sum by 8
 ;ror  AccumL
 ;lsr  AccumH
 ;ror  AccumL

 mov  a,Stell_L				;Register f. die Pulsdauer f. Vergleich kopieren..
 cpi  a,#pcpwm_freq			;..maximale Pulsdauer erreicht? ( Ausgang High? )
 brcc _skip					;JA -> Pulsdauer nicht mehr incrementieren 
 sts  PULS,Stell_L           ;..PWM Pulsdauer anpassen
 rjmp _main
_skip:
 ldi  a,#pcpwm_freq			;Phase Correct PWM Frequenz..
 sts  PULS,a				;..Pulsweite auf Maximum begrenzen
 rjmp _main
_stell_null:
 ldi  a,#PwmNon				;Fast PWM Non Invering Mode.. 
 out  TCCR0A,a				;..einstellen

 sts  PULS,Stell_L			;Pulsweite aktualisieren
 rjmp _main

 /*
_pwm_aus:
 cbi  PWM_PORT,PWM_PORT.PWM_1;Low-Pegel am PWM-Ausgang erzeugen..
 in   a,TCCR0A				;..hierzu auf Normale Portfunktion..
 cbr  a,1<<COM0A1|1<<COM0A0	;..umschalten und jetzt wird der..
 out  TCCR0A,a				;..Portpin auf Low geschaltet.
 rjmp _main
*/
;
;
;
;
;
;
_led_taster: 
 cbi  DRG_PORT,drg.stop		;LED einschalten -> Drehgebertaster wurde betaetigt 
 ;cbr  flag_reg,1<<drg.links ;Flag fuer Drehgeber links  gedreht loeschen
 ;cbr  flag_reg,1<<drg.rechts;Flag fuer Drehgeber rechts gedreht loeschen
 
 clr  eins					;Register neu mit Eins initialisieren, um spaeter.. 
 inc  eins					;..Lauflicht zu realisieren

 ;out  OUT_PORT,null			;LED-Anzeigeband = Null
 
 /*
_rs232:  
 rcall _warte_udre          ;TESTZWECKE ########################################
 ;ld   twi_data,z            ;TESTZWECKE ########################################
 sts   UDR0,flanken_zlr      ;TESTZWECKE ########################################
 
 ret						;Ruecksprung aus RS232-Senden
;
;Auf das Freiwerden des USART-Datenregisters warten
;
_warte_udre:                 ;TESTZWECKE #####################################################################
 push a
_warte_udre1:
 lds  a,UCSR0A
 sbrs a,UDRE0              
 rjmp _warte_udre1 
 pop  a          
 ret                        ;TESTZWECKE USART Datenregister frei###############################################
 */

 ret                       ;Ruecksprung aus Motor PID-Regeln 
 
